/*
 Languages for Scientific Computing
 ----
*/
// to compile:
// gcc inputname.c -o outputname -Wall 


#include <stdlib.h>   // (almost) always necessary
#include <stdio.h>    // (almost) always necessary


/* the MAIN program starts here */
int main(  )
{
   // #6a  pointers
   int i;  
   double *pt;  // pt is a pointer (address) to a double

   double vec[10] = {-10., 0.1, 3.2, 4.4, -4.0, -55, .66, 7, 8, -9};
   // smallest addressable unit of memory: byte
   // 1 double: 8 bytes
   
   // &object returns the memory address of the object
   pt = &vec[0];    // pt points to the beginning of the vector vec

   // value of the object pointed
   printf("val: %g\n", *pt );
   
   // value of the pointer
   printf("pt: %p\n", pt );

   
   *pt = 10;
   for( i=0; i<10; i++ )
      printf("vec[%d] = %g\n", i, vec[i]);
   


   // #6b
   pt = vec;      // this is identical to pt = &vec[0]
   printf("pt: %p\n", pt );
   
   pt = &vec[3];  
   // value of the pointer and of the object pointed
   printf("pt: %p\tval: %g\n", pt, *pt );



   *pt = -33;

   for( i=0; i<10; i++ )
      printf("vec[%d] = %g\t address: %p\n", i, vec[i], &vec[i]);


   // {-10., 0.1, 1.2, 3.3, -4.0, -55, .66, 7, 8, -9};
   // pointer arithmetic:
   printf("pt: %p\tval: %g\tval: %g\n", pt+1, *(pt+1), (*pt)+1 );

   
   return( 0 );
}



